<template>
  <v-img class="ma-auto mb-6" :width="store.token ? 300 : 400" :src="store.logoUrl" />

  <v-container class="text-center">
    <v-row>
      <v-col :class="`${store.token ? 'text-h4 text-sm-h3' : 'text-h4 text-sm-h2'} font-weight-bold`">
        {{ $t("home.title") }}
      </v-col>
    </v-row>
    <v-row v-if="store.user" class="text-h4 mt-0">
      <v-col>
        {{
          $t("home.welcomeMessage", {
            name: `${store.user.firstname} ${store.user.lastname}`,
          })
        }}
      </v-col>
    </v-row>
  </v-container>

  <v-container>
    <v-row v-if="store.user?.allowedToIdentify">
      <v-col class="text-h4 text-center">
        {{ $t("home.identificationSectionHeader") }}
      </v-col>
    </v-row>
    <function-cards-row v-if="store.user?.allowedToIdentify" :cards="identFunctions" />
    <div v-if="store.user">
      <v-row>
        <v-col class="text-h4 text-center">
          {{ $t("home.requestSectionHeader") }}
        </v-col>
      </v-row>
      <function-cards-row :cards="certificateTypes" />
      <div v-if="hasStoredCertificates">
        <v-row>
          <v-col class="text-h4 text-center">
            {{ $t("home.manageSectionHeader") }}
          </v-col>
        </v-row>
        <function-cards-row :cards="manageFunctions" />
      </div>
    </div>
  </v-container>

  <v-container>
    <v-row>
      <v-col class="text-center">
        <v-btn
          :color="store.token ? 'red' : 'primary'"
          size="x-large"
          variant="elevated"
          @click="store.token ? logout() : login()"
        >
          <icon-with-text icon="key" size="large">
            {{ store.token ? $t("home.logoutButton") : $t("home.loginButton") }}
          </icon-with-text>
        </v-btn>
      </v-col>
    </v-row>
  </v-container>

  <v-container v-if="store.logoutError" class="text-h6 font-weight-light text-center">
    <v-row>
      <v-col>
        {{ $t("home.sessionExpired.message") }}
      </v-col>
    </v-row>
    <v-row no-gutters>
      <v-col>
        <v-btn variant="text" prepend-icon="fas fa-circle-info py-4">
          {{ $t("dialog.moreInfoButton") }}
          <v-dialog v-model="sessionExpiredInfoDialogOpened" width="auto" max-width="1000" activator="parent">
            <v-card class="pa-2">
              <v-card-title>{{ $t("home.sessionExpired.moreInfo.title") }}</v-card-title>
              <v-card-text>
                <div class="mb-4">
                  {{ store.logoutError.getLocalized($t) }}
                </div>
                <div>
                  <span v-if="store.logoutError.requestId" class="font-weight-bold pr-2"
                    >{{ $t("errors.requestIdLabel") }}:</span
                  ><span>{{ store.logoutError.requestId }}</span>
                </div>
              </v-card-text>
              <v-card-actions>
                <v-btn color="secondary" block @click="sessionExpiredInfoDialogOpened = false">
                  {{ $t("dialog.closeButton") }}
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-btn>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { login, logout, requestBackend, store } from "@/ts/common";
import { PKCS12Type, StoreType } from "@/ts/types";
import { FunctionCardType, FunctionCardTypes } from "@/components/FunctionCard.vue";
import FunctionCardsRow from "@/components/FunctionCardsRow.vue";
import IconWithText from "@/components/IconWithText.vue";

type HomeData = {
  store: StoreType;
  hasStoredCertificates: boolean;
  sessionExpiredInfoDialogOpened: boolean;
  certificateTypes: Array<FunctionCardType>;
  identFunctions: Array<FunctionCardType>;
  manageFunctions: Array<FunctionCardType>;
};

export default defineComponent({
  components: { IconWithText, FunctionCardsRow },
  data(): HomeData {
    return {
      store: store,
      hasStoredCertificates: false,
      sessionExpiredInfoDialogOpened: false,
      certificateTypes: [
        {
          type: FunctionCardTypes.RequestCertificates,
          id: "personal",
          icon: "user",
          target: "/request-personal",
          enabled: false,
        },
        {
          type: FunctionCardTypes.RequestCertificates,
          id: "function",
          icon: "people-group",
          target: "/request-functional",
          enabled: false,
        },
        {
          type: FunctionCardTypes.RequestCertificates,
          id: "server",
          icon: "computer",
          target: this.$t("request.server.instructionsUrl"),
          enabled: false,
        },
      ],
      identFunctions: [
        {
          type: FunctionCardTypes.Identification,
          id: "view",
          icon: "eye",
          target: "/",
          enabled: false,
        },
        {
          type: FunctionCardTypes.Identification,
          id: "create",
          icon: "id-card",
          target: "/create-ident",
          enabled: true,
        },
      ],
      manageFunctions: [
        {
          type: FunctionCardTypes.ManageCertificates,
          id: "distribute",
          icon: "share-nodes",
          target: "/distribute",
          enabled: true,
        },
      ],
    };
  },
  async beforeMount() {
    this.hasStoredCertificates = await requestBackend<Array<PKCS12Type>>("/vault/pkcs12").then(
      (data) => {
        return data.length > 0;
      },
      () => {
        return false;
      }
    );
  },
  methods: {
    login: login,
    logout: logout,
  },
});
</script>
